#!/usr/bin/perl -w

##################
#
# PolluStop Initial Setup Script
# This script is provided as a sample only
# It may not be suitable for your system, and should be carefully examined before usage
# Please ask for support if you are not sure, the initial setup provided by this script
# can be done by Niversoft and adapted to your needs, such as including a managed layer
# of protection between your users drop boxes and PolluStop database.
#
# This script is provided "as is" without express or implied warranty.
#
# NIVERSOFT IDES LOGICIELLES AND NICOLAS HATIER DISCLAIMS ALL WARRANTIES WITH
# REGARD TO THIS SCRIPT, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
# AND FITNESS, IN NO EVENT SHALL NIVERSOFT IDES LOGICIELLES OR NICOLAS HATIER
# BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
# OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
# CONNECTION WITH THE USE OR PERFORMANCE OF THIS SCRIPT.
#
# This script requires CLI.pm and its dependencies. CLI.pm can be downloaded
# from http://www.stalker.com/CGPerl/
#
####################

use CLI;
use strict;

print "Server Name or IP?\n>";
my $server = <>;
chomp $server;
print "Domain to modify (enter \"ALL\" to modify all available domains) ?\n>";
my $domain = <>;
chomp $domain;
print "Postmaster password?\n";
my $password = <>;
chomp $password;

my $cli = new CGP::CLI( { PeerAddr => "$server",
			PeerPort => 106,
			login    => 'postmaster',
			password => "$password"
			} )
	|| die "Can't login to CGPro: ".$CGP::ERR_STRING."\n";

my @domains;

if ($domain eq "ALL")
{
   my $domains = $cli->ListDomains()  || die "Error, can't list domains:\n".$cli->getErrMessage."\n";
   @domains = @{$domains};
}
else
{
   push @domains, $domain;
}

foreach $domain (@domains)
{
   print "********* DOMAIN: $domain ***********\n";
   my $accList = $cli->ListAccounts($domain) || die "can't list accounts";

   foreach my $account (keys %{$accList})
   {
      $account = "$account\@$domain";
      print "$account\n";
   	my $subs = $cli->GetAccountSubscription($account) || print "Error: ".$cli->getErrMessage.", for account $account";
   	my @subs = @{$subs};
   	push @subs, "Junk Mail";
   	push @subs, "Drop";
   	push @subs, "Drop/Spam";
   	push @subs, "Drop/Good";
   	$cli->SetAccountSubscription($account, \@subs) || print "Error: ".$cli->getErrMessage.", for account $account";

   	my $aliases = $cli->GetMailboxAliases($account) || print "Error: ".$cli->getErrMessage.", for account $account";
   	my %aliases = %{$aliases};
   	$aliases{"Drop"} = "~pollustop/Drop";
   	$cli->SetMailboxAliases($account, \%aliases) || print "Error: ".$cli->getErrMessage.", for account $account";

   	$cli->CreateMailbox($account, "Junk Mail") || print "Error: ".$cli->getErrMessage.", for account $account\n";
   }
}

$cli->Logout;


